unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ScktComp, StdCtrls, WinSock, Buttons, ComCtrls,
  Jpeg, MPlayer, IdComponent, IdTCPConnection, IdTCPClient,
  IdHTTP, IdBaseComponent, ShellApi;

type
  TForm1 = class(TForm)
    Cli: TClientSocket;
    Srv: TServerSocket;
    Nick: TEdit;
    Stk: TLabel;
    Frase: TMemo;
    Lista: TListBox;
    Servidor: TEdit;
    Abook: TNotebook;
    Pergresp: TMemo;
    btSelec: TSpeedButton;
    btQuest: TSpeedButton;
    btEnviar: TSpeedButton;
    btResp: TSpeedButton;
    btCerto: TSpeedButton;
    btErrado: TSpeedButton;
    btEusei: TSpeedButton;
    btChat: TSpeedButton;
    btTela: TSpeedButton;
    btSom: TSpeedButton;
    btConec: TSpeedButton;
    Tela: TImage;
    Chat: TRichEdit;
    Memo2: TMemo;
    btCam: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    Memo3: TMemo;
    Edit1: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Edit2: TEdit;
    btApres: TSpeedButton;
    Label5: TLabel;
    Edit3: TEdit;
    btAdic: TSpeedButton;
    Sb1: TScrollBar;
    Label6: TLabel;
    Cb1: TCheckBox;
    Cb2: TCheckBox;
    Cb3: TCheckBox;
    Cb4: TCheckBox;
    Web2: TIdHTTP;
    Deck: TMediaPlayer;
    btAlter: TSpeedButton;
    Panel1: TPanel;
    Image1: TImage;
    Label7: TLabel;
    procedure SrvClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure CliRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure SrvClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure FraseKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure btChatClick(Sender: TObject);
    procedure btCamClick(Sender: TObject);
    procedure btConecClick(Sender: TObject);
    procedure btApresClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure CliConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure CliError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure CliDisconnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure btAdicClick(Sender: TObject);
    procedure Sb1Change(Sender: TObject);
    procedure Sb1Scroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure btSelecClick(Sender: TObject);
    procedure btQuestClick(Sender: TObject);
    procedure btRespClick(Sender: TObject);
    procedure btEnviarClick(Sender: TObject);
    procedure btEuseiClick(Sender: TObject);
    procedure btCertoClick(Sender: TObject);
    procedure btErradoClick(Sender: TObject);
    procedure FraseKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btTelaClick(Sender: TObject);
    procedure btSomClick(Sender: TObject);
    procedure btAlterClick(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
  public
    procedure MandaConectados;
    procedure MandaParaTodos(Msg: string);
    function AchaJog(Nik: string): TCustomWinSocket;
    function GetLocalIP : string;
    procedure DecodeCli(Cmd,Rec: string);
  end;

var
  Form1: TForm1;

implementation
{$R *.dfm}

type Jog = record
     Nik: string;
     Pts: integer;
end;

type pJog = ^Jog;

const
  Id: string = '$-$';

var
  Modo: byte = 0;
  Questoes: TStringList;
  Quest: integer;
  Quem: string = '';
  Vez: boolean = false;


procedure TForm1.FormCreate(Sender: TObject);
begin
  Chat.Paragraph.FirstIndent:= 0;
  Chat.Paragraph.LeftIndent:= 0;
  Chat.HideSelection:= false;
  Chat.Font.Size:= 9;
  Servidor.Text:= GetLocalIP;
  Pergresp.Lines.Clear;
  Frase.Lines.Clear;
  Questoes:= TStringList.Create;
  try Questoes.LoadFromFile('questoes.txt');
      Sb1.Max:= (Questoes.Count div 4)-1;
  except Questoes.Clear;
         Sb1.Max:= 0;
  end;
  Label6.Caption:= IntToStr(Sb1.Position)+'  |  '+IntToStr(Sb1.Max + 1);
end;


procedure TForm1.FormDestroy(Sender: TObject);
begin
  if Srv.Active then Srv.Close;
  if Cli.Active then Cli.Close;
  Questoes.Free;
end;


//= Conectar: ser jogador
procedure TForm1.btConecClick(Sender: TObject);
begin
  if Cli.Active then begin
     Cli.Active:= false;
     btConec.Caption:= 'conectar';
     btApres.Visible:= true;
     btCam.Visible:= true;
     btSelec.Visible:= true;
     btQuest.Visible:= true;
     btEnviar.Visible:= true;
     btResp.Visible:= true;
     btCerto.Visible:= true;
     btErrado.Visible:= true;
     exit;
  end;
  Cli.Active:= true;
  while not Cli.Active do Application.ProcessMessages;
  btConec.Caption:= 'descon...';
  Cli.Socket.SendText(Id+'slc:'+Nick.Text);
  Abook.PageIndex:= 0;
  Chat.Paragraph.FirstIndent:= 0;
  Chat.Paragraph.LeftIndent:= 0;
  Chat.SelAttributes.Color:= clMaroon;
  Chat.SelAttributes.Style:= [];
  Chat.Lines.Add('Quiz Maker operando em modo jogador');
  Chat.Lines.Add('');
  Modo:= 2;
  btApres.Visible:= false;
  btCam.Visible:= false;
  btSelec.Visible:= false;
  btQuest.Visible:= false;
  btEnviar.Visible:= false;
  btResp.Visible:= false;
  btCerto.Visible:= false;
  btErrado.Visible:= false;
  Frase.SetFocus;
end;


//= Servidor: ser servidor
procedure TForm1.btApresClick(Sender: TObject);
begin
  if Srv.Active then begin
     if Cli.Active then Cli.Active:= false;
     Srv.Active:= false;
     btApres.Caption:= 'apresentar';
     btConec.Visible:= true;
     btEusei.Visible:= true;
     btCerto.Visible:= true;
     btErrado.Visible:= true;
     exit;
  end;
  try Srv.Active:= true;
  finally Stk.Caption:= 'Sevidor ligado...';
    btApres.Caption:= 'descon...';
    Abook.PageIndex:= 0;
    Chat.Paragraph.FirstIndent:= 0;
    Chat.Paragraph.LeftIndent:= 0;
    Chat.SelAttributes.Color:= clMaroon;
    Chat.SelAttributes.Style:= [];
    Chat.Lines.Add('Quiz Maker operando em modo apresentador');
    Chat.Lines.Add('');
    Modo:= 1;
    btConec.Visible:= false;
    btEusei.Visible:= false;
    btCerto.Visible:= false;
    btErrado.Visible:= false;
    if not Cli.Active then begin
           Cli.Active:= true;
           while not Cli.Active do Application.ProcessMessages;
    end;
    Cli.Socket.SendText(Id+'slc:'+Nick.Text);
    Frase.SetFocus;
  end;
end;


//= Ver a tela
procedure TForm1.btTelaClick(Sender: TObject);
begin
  Abook.PageIndex:= 1;
end;


//= Tocar o som
procedure TForm1.btSomClick(Sender: TObject);
begin
  Deck.Open;
  if pos('.avi',Deck.FileName) <> 0 then begin
     Abook.PageIndex:= 3;
     Deck.DisplayRect:= bounds(0,0,Panel1.Width,Panel1.Height);
  end;
  Deck.Play;
end;


//------------------------------------------------------------------------------
//--- Obtem o IP do usurio ----------------------------------------------------
function TForm1.GetLocalIP : string;
type
  TaPInAddr = array [0..10] of PInAddr;
  PaPInAddr = ^TaPInAddr;
var
  phe  : PHostEnt;
  pptr : PaPInAddr;
  Buffer : array [0..63] of char;
  I    : Integer;
  GInitData      : TWSADATA;
begin
  WSAStartup($101, GInitData);
  Result := '';
  GetHostName(Buffer, SizeOf(Buffer));
  phe :=GetHostByName(buffer);
  if phe = nil then Exit;
  pptr := PaPInAddr(Phe^.h_addr_list);
  I := 0;
  while pptr^[I] <> nil do begin
    result:= StrPas(inet_ntoa(pptr^[I]^));
    Inc(I);
  end;
  WSACleanup;
end;


procedure Executar(Nome: string; args: string = '');
begin
  ShellExecute(0, PChar('open'), PChar(Nome), PChar(args), nil, SW_MINIMIZE);
end;





//******************************************************************************
// Servidor                                                           Servidor
//******************************************************************************

//=== Servidor recebe uma mensagem =============================================
procedure TForm1.SrvClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
  S,Cmd: string;
  Jg: pJog;
begin
  S:= Socket.ReceiveText;
  Cmd:= copy(S,4,3);
  S:= copy(S,8,length(S));

  //== Jogador conecta no jogo ::
  if Cmd = 'slc' then begin
     if Socket.Data = nil then begin
        new(Jg);
        Jg.Nik:= S;
        if S <> Nick.Text then Jg.Pts:= 0 else Jg.Pts:= -1;
        socket.Data:= Jg;
        MandaParaTodos(Id+'avs:'+S+' entrou no jogo!');
        MandaConectados;
        Socket.SendText(Id+'avs:'+Edit3.Text);
     end;
  end;

  //== Repetidor de comandos ::
  if (Cmd = 'msg') or (Cmd = 'rsp') then begin
     MandaParaTodos(Id+Cmd+':'+S);
  end;

  //== Eu sei a resposta ::
  if Cmd = 'eus' then begin
     if Quem = '' then Quem:= S;
     MandaParaTodos(Id+'tes:');
     MandaParaTodos(Id+'avs:'+S+' vai responder...');
     Socket.SendText(Id+'vai:');
     Stk.Caption:= S+' vai responder a questo...';
  end;



end;


procedure TForm1.SrvClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  if socket.Data <> nil then Dispose(Socket.Data);
  MandaConectados;
end;


//=== Liga o servidor ==========================================================


//=== Encontra um jogador nas conexes =========================================
function TForm1.AchaJog(Nik: string): TCustomWinSocket;
var
  Tm: integer;
  Jg: pJog;
begin
  result:= nil;
  for Tm:= 0 to Srv.Socket.ActiveConnections -1 do begin
      Jg:= Srv.Socket.Connections[Tm].Data;
      if Jg.Nik = Nik then begin
        result:= Srv.Socket.Connections[Tm];
        exit;
      end;
  end;
end;


//== Manda a lista de todos os jogadores conectados ============================
procedure TForm1.MandaConectados;
var
  Tm: integer;
  S: string;
  Jg: pJog;
begin
  S:= Id+'lst:';
  for Tm:= 0 to Srv.Socket.ActiveConnections -1 do begin
      Jg:= Srv.Socket.Connections[Tm].Data;
      if Jg.Pts = -1 then S:= S + '*** '+Jg.Nik + '|'
      else S:= S + format('%.3d',[Jg.Pts])+' '+Jg.Nik + '|';
  end;
  MandaParaTodos(S);
end;


//=== Manda comando para todos os jogadores conectados =========================
procedure TForm1.MandaParaTodos(Msg: string);
var
  Tm: integer;
begin
  for Tm:= 0 to Srv.Socket.ActiveConnections -1 do
      Srv.Socket.Connections[Tm].SendText(Msg);
end;


//= Seleciona uma questo ===
procedure TForm1.btSelecClick(Sender: TObject);
begin
  if Cb4.Checked then Quest:= Random(Sb1.Max+1)
  else Quest:= Sb1.Position;
  Pergresp.Font.Color:= clBlack;
  Pergresp.Text:= Questoes[Quest*4];
end;


//= Questo selecionada ===
procedure TForm1.btQuestClick(Sender: TObject);
begin
  Pergresp.Font.Color:= clBlack;
  Pergresp.Text:= Questoes[Quest*4];
end;

//= Resposta  questo ===
procedure TForm1.btRespClick(Sender: TObject);
begin
  Pergresp.Font.Color:= clMaroon;
  Pergresp.Text:= Questoes[Quest*4+1];
end;

//= Enviar questo aos jogadores ===
procedure TForm1.btEnviarClick(Sender: TObject);
begin
  MandaParaTodos(Id+'avs: Respondam a questo...');
  MandaParaTodos(Id+'qst:'+ Questoes[Quest*4]);
  if Cb1.Checked and (Questoes[Quest*4+2] <> '') then MandaParaTodos(Id+'img:'+ Questoes[Quest*4+2]);
  if Cb2.Checked and (Questoes[Quest*4+3] <> '') then begin
    if pos('.avi',Questoes[Quest*4+3]) <> 0 then MandaParaTodos(Id+'avi:'+ Questoes[Quest*4+3])
    else MandaParaTodos(Id+'som:'+ Questoes[Quest*4+3]);
  end;
  Quem:= '';
  btCerto.Visible:= true;
  btErrado.Visible:= true;
end;

//= Resposta certa ===
procedure TForm1.btCertoClick(Sender: TObject);
var
  Jg: pJog;
  Sk: TCustomWinSocket;
begin
  if Quem = '' then exit;
  MandaParaTodos(Id+'avs:'+ Quem + ' acertou!!!');
  Sk:= AchaJog(Quem);
  Jg:= Sk.Data;
  Jg.Pts:= Jg.Pts + 1;
  btCerto.Visible:= false;
  btErrado.Visible:= false;
  MandaConectados;
end;

//= Resposta errada ===
procedure TForm1.btErradoClick(Sender: TObject);
var
  Jg: pJog;
  Sk: TCustomWinSocket;
begin
  if Quem = '' then exit;
  MandaParaTodos(Id+'avs:'+ Quem + ' errou!!!');
  if Cb3.Checked then begin
     Sk:= AchaJog(Quem);
     Jg:= Sk.Data;
     if Jg.Pts > 0 then Jg.Pts:= Jg.Pts - 1;
     MandaConectados;
  end;
  btCerto.Visible:= false;
  btErrado.Visible:= false;
end;





//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// Cliente                                                            Cliente
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

procedure TForm1.CliConnect(Sender: TObject; Socket: TCustomWinSocket);
begin
  Nick.Enabled:= false; Servidor.Enabled:= false;
end;

procedure TForm1.CliDisconnect(Sender: TObject; Socket: TCustomWinSocket);
begin
  Nick.Enabled:= true; Servidor.Enabled:= true;
end;


procedure TForm1.CliError(Sender: TObject; Socket: TCustomWinSocket;
  ErrorEvent: TErrorEvent; var ErrorCode: Integer);
begin
  Stk.Caption:= 'Erro no acesso ao servidor.';
  ErrorCode:= 0;
end;


//== Cliente recebe uma mensagem do servidor ===================================
procedure TForm1.CliRead(Sender: TObject; Socket: TCustomWinSocket);
var
  Rec,Cmd,S: String;
  Tm: integer;
begin
  Rec:= Socket.ReceiveText;
  Tm:= 1; S:= '';
  while Tm <> 0 do begin
        Cmd:= copy(Rec,4,3);
        Rec:= copy(Rec,8,length(Rec));
        Tm:= pos('$-$',Rec);
        if Tm = 0 then DecodeCli(Cmd,Rec) else begin
           S:= copy(Rec,Tm,length(Rec));
           Rec:= copy(Rec,1,Tm-1);
           DecodeCli(Cmd,Rec);
           Rec:= S;
        end;
  end;
end;


procedure TForm1.DecodeCli(Cmd,Rec: string);
var
  S: string;
  Tp: integer;
  MyStream: TMemoryStream;
begin

  //- Comando para montar a lista de conectados
  if Cmd = 'lst' then begin
     Lista.Items.Clear;
     while Rec <> '' do begin
           Tp:= pos('|',Rec);
           S:= copy(Rec,1,Tp-1);
           Rec:= copy(Rec,Tp+1,length(Rec));
           Lista.Items.Add(S);
     end;
     exit;
  end;

  //- Recebe uma mensagem para o board
  if Cmd = 'msg' then begin
     S:= copy(Rec,1,pos(': ',Rec));
     Rec:= copy(Rec,Length(S)+2,length(Rec));
     Chat.Lines.Add('');
     Chat.Paragraph.FirstIndent:= 3;
     Chat.Paragraph.LeftIndent:= 0;
     Chat.SelAttributes.Color:= clBlack;
     Chat.SelAttributes.Style:= [fsBold];
     Chat.Lines.Add(S);
     Chat.Paragraph.FirstIndent:= 15;
     Chat.Paragraph.LeftIndent:= 0;
     Chat.SelAttributes.Style:= [];
     Chat.Lines.Add(Rec);
    exit;
  end;

  //- Recebe um aviso para o board
  if Cmd = 'avs' then begin
     Chat.Lines.Add('');
     Chat.Paragraph.FirstIndent:= 0;
     Chat.Paragraph.LeftIndent:= 0;
     Chat.SelAttributes.Color:= clNavy;
     Chat.SelAttributes.Style:= [fsBold];
     Chat.Lines.Add(Rec);
    exit;
  end;

  //- Recebe uma mensagem de status
  if Cmd = 'sys' then begin
     Stk.Caption:= Rec;
     exit;
  end;

  //- Recebe uma questo
  if Cmd = 'qst' then begin
     Pergresp.Font.Color:= clBlack;
     Pergresp.Text:= Rec;
  end;

  //- Avisa pra responder
  if Cmd = 'vai' then begin
     Vez:= true;
     Stk.Caption:= 'Responda a questo...';
  end;

  //- Recebe uma resposta do jogador
  if Cmd = 'rsp' then begin
     S:= copy(Rec,1,pos(': ',Rec));
     Rec:= copy(Rec,Length(S)+2,length(Rec));
     Chat.Lines.Add('');
     Chat.Paragraph.FirstIndent:= 3;
     Chat.Paragraph.LeftIndent:= 0;
     Chat.SelAttributes.Color:= clMaroon;
     Chat.SelAttributes.Style:= [fsBold];
     Chat.Lines.Add(S);
     Chat.Paragraph.FirstIndent:= 15;
     Chat.Paragraph.LeftIndent:= 0;
     Chat.SelAttributes.Style:= [];
     Chat.Lines.Add(Rec);
    exit;
  end;

  //- Tempo esgotado... um jogador vai responder
  if Cmd = 'tes' then begin
     Abook.PageIndex:= 0;
  end;

  //- Carrega uma imagem
  if Cmd = 'img' then begin
     MyStream:= TMemoryStream.Create;
     Web2.Get(Rec,MyStream);
     Abook.PageIndex:= 1;
     MyStream.SaveToFile('tela.jpg');
     //Tela.Picture.Graphic.LoadFromStream(MyStream);
     Tela.Picture.LoadFromFile('tela.jpg');
     MyStream.Free;
  end;

  //- Carrega um som
  if Cmd = 'som' then begin
     MyStream:= TMemoryStream.Create;
     Web2.Get(Rec,MyStream);
     Abook.PageIndex:= 1;
     MyStream.SaveToFile('som.mp3');
     Deck.FileName:= 'som.mp3';
     Deck.Open;
     Deck.Play;
     MyStream.Free;
  end;

  //- Carrega um avi
  if Cmd = 'avi' then begin
     MyStream:= TMemoryStream.Create;
     Web2.Get(Rec,MyStream);
     Abook.PageIndex:= 1;
     MyStream.SaveToFile('filme.avi');
     Abook.PageIndex:= 3;
     Deck.FileName:= 'filme.avi';
     Deck.Open;
     Deck.DisplayRect:= bounds(0,0,Panel1.Width,Panel1.Height);
     Deck.Play;
     MyStream.Free;
  end;
end;


procedure TForm1.FraseKeyDown(Sender: TObject; var Key: Word;
 Shift: TShiftState);
begin
  if Key = vk_Return then begin
     Stk.Caption:= '';
     if Vez then
        Cli.Socket.SendText(Id+'rsp:'+Nick.Text+' respondeu: '+Frase.Text)
     else
        Cli.Socket.SendText(Id+'msg:'+Nick.Text+' falou: '+Frase.Text);
     Vez:= false;
  end;
end;


procedure TForm1.FraseKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = vk_Return then Frase.Lines.Clear;
end;


procedure TForm1.btEuseiClick(Sender: TObject);
begin
  Cli.Socket.SendText(Id+'eus:'+Nick.Text);
end;




//==============================================================================
//                       pgina e controles do chat
//==============================================================================
procedure TForm1.btChatClick(Sender: TObject);
begin
  Abook.PageIndex:= 0;
end;




//==============================================================================
//                pgina e controles do camarim do apresentador
//==============================================================================
procedure TForm1.btCamClick(Sender: TObject);
begin
  Abook.PageIndex:= 2;
end;

procedure TForm1.btAdicClick(Sender: TObject);
begin
  Questoes.Add(Memo2.Text);
  Questoes.Add(Memo3.Text);
  Questoes.Add(Edit1.Text);
  Questoes.Add(Edit2.Text);
  Questoes.SaveToFile('questoes.txt');
  Sb1.Max:= Sb1.Max + 1;
  Sb1.Position:= Sb1.Max -1;
end;

procedure TForm1.btAlterClick(Sender: TObject);
begin
  Questoes[Sb1.Position*4]:= Memo2.Text;
  Questoes[Sb1.Position*4+1]:= Memo3.Text;
  Questoes[Sb1.Position*4+2]:= Edit1.Text;
  Questoes[Sb1.Position*4+3]:= Edit2.Text;
  Questoes.SaveToFile('questoes.txt');
end;


procedure TForm1.Sb1Change(Sender: TObject);
begin
  Memo2.Text:= Questoes[Sb1.Position * 4];
  Memo3.Text:= Questoes[Sb1.Position * 4 + 1];
  Edit1.Text:= Questoes[Sb1.Position * 4 + 2];
  Edit2.Text:= Questoes[Sb1.Position * 4 + 3];
end;

procedure TForm1.Sb1Scroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
  Label6.Caption:= IntToStr(Sb1.Position+1)+'  |  '+IntToStr(Sb1.Max + 1);
end;









procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Executar('http://www.tilt.net/index.htm')
end;

end.





